<?php
/*
KeyCAPTCHA plugin for WordPress
Version		2.1.0
Author		ITNP, Jsc
Author URI	https://www.keycaptcha.com
License		GNU GPL2
*/
/*
Copyright (C) 2010 ITNP, Jsc (www.keycaptcha.com). All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License,
version 2, as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

if (isset($_POST['submit']))
{
	$optionarray_update = array
		(
			'keycaptcha_site_private_key' =>(isset( $_POST['keycaptcha_site_private_key'] ) ) ? $_POST['keycaptcha_site_private_key'] : '',
			'keycaptcha_code' => (isset( $_POST['keycaptcha_code'] ) ) ? $_POST['keycaptcha_code'] : '',
			'keycaptcha_on_register' => (isset( $_POST['keycaptcha_on_register'] ) ) ? 'true' : 'false',
			'keycaptcha_on_login' => (isset( $_POST['keycaptcha_on_login'] ) ) ? 'true' : 'false',
			'keycaptcha_on_lostpwd' => (isset( $_POST['keycaptcha_on_lostpwd'] ) ) ? 'true' : 'false',
			'keycaptcha_on_cf7' =>(isset( $_POST['keycaptcha_on_cf7'] ) ) ? 'true' : 'false',
			
		);
	foreach ($optionarray_update as $key => $val)
	{
		$optionarray_update[$key] = str_replace('&quot;','"',trim($val));
	}
	update_option('keycaptcha_vars_db', $optionarray_update);
	$this->keycaptcha_vars = get_option('keycaptcha_vars_db');
	foreach($this->keycaptcha_vars as $key => $val)
	{
		$this->keycaptcha_vars[$key] = str_replace('\\','',$val);
	}
	$this->kc_o = &new KeyCAPTCHA_CLASS($this->keycaptcha_vars['keycaptcha_site_private_key'], $this->keycaptcha_vars['keycaptcha_code']);
	if (function_exists('wp_cache_flush'))
	{
		wp_cache_flush();
	}
}
?>

<?php if ( !empty($_POST ) ) : ?>
<div id="message" class="updated fade"><p><strong><?php _e('Settings saved.', 'keycaptcha') ?></strong></p></div>
<?php endif; ?>
<div class="kc_div_settings">
	<h2><?php _e('KeyCAPTCHA Settings', 'keycaptcha') ?></h2>
	<form name="formsettings" action="<?php echo admin_url( 'plugins.php?page=keycaptcha/keycaptcha.php' );?>" method="post">
		<fieldset class="kc_fs_settings">
			<h3><?php _e('General settings', 'keycaptcha') ?></h3>
			<table width="100%" cellspacing="2" cellpadding="5" class="form-table">
				<tr>
					<th scope="row"><?php _e('Private key:', 'keycaptcha') ?></th>
					<td>
						<input name="keycaptcha_site_private_key" id="keycaptcha_site_private_key" type="text" style="width:540px;" value="<?php echo($this->keycaptcha_vars['keycaptcha_site_private_key']); ?>" />
					</td>
				</tr>
				<tr>
					<th scope="row"><?php _e('KeyCAPTCHA code:', 'keycaptcha') ?></th>
					<td>
						<textarea id="keycaptcha_code" name="keycaptcha_code" rows="10" style="width:540px;"><?php echo($this->keycaptcha_vars['keycaptcha_code']); ?></textarea>
					</td>
				</tr>
				<tr>
					<th scope="row"><?php _e('KeyCAPTCHA on registration', 'keycaptcha') ?></th>
					<td>
						<input name="keycaptcha_on_register" id="keycaptcha_on_register" type="checkbox" <?php if ( $this->keycaptcha_vars['keycaptcha_on_register'] == 'true' ) echo ' checked="checked" '; ?> />
						<label for="keycaptcha_on_register">
							<?php _e('Check this box to enable KeyCAPTCHA protection on the register form.', 'keycaptcha') ?>
						</label>
					</td>
				</tr>
				<tr>
					<th scope="row"><?php _e('KeyCAPTCHA on login', 'keycaptcha') ?></th>
					<td>
						<input name="keycaptcha_on_login" id="keycaptcha_on_login" type="checkbox" <?php if ( $this->keycaptcha_vars['keycaptcha_on_login'] == 'true' ) echo ' checked="checked" '; ?> />
						<label for="keycaptcha_on_register">
							<?php _e('Check this box to enable KeyCAPTCHA protection on the login form. This option is supported by WordPress ver. 2.8 or above.', 'keycaptcha') ?>
						</label>
					</td>
				</tr>
				<tr>
					<th scope="row"><?php _e('KeyCAPTCHA on lost password', 'keycaptcha') ?></th>
					<td>
						<input name="keycaptcha_on_lostpwd" id="keycaptcha_on_lostpwd" type="checkbox" <?php if ( $this->keycaptcha_vars['keycaptcha_on_lostpwd'] == 'true' ) echo ' checked="checked" '; ?> />
						<label for="keycaptcha_on_register">
							<?php _e('Check this box to enable KeyCAPTCHA protection on "Lost your password" form. This option is supported by WordPress ver. 2.7 or above.', 'keycaptcha') ?>
						</label>
					</td>
				</tr>
				<tr>
					<th scope="row"><?php _e('KeyCAPTCHA on Contact Form 7', 'keycaptcha') ?></th>
					<td>
						<input name="keycaptcha_on_cf7" id="keycaptcha_on_cf7" type="checkbox" <?php if ( $this->keycaptcha_vars['keycaptcha_on_cf7'] == 'true' ) echo ' checked="checked" '; ?> />
						<label for="keycaptcha_on_register">
							<?php _e(	'Check this box to enable KeyCAPTCHA protection on Contact Form 7.
									<br>
									<div style="margin-left:50px;">
									<p>To integarte KeyCAPTCHA with <b>Contact Form 7</b> please use the following instuctions:
									<br>
									<ol>
										<li>Copy the following tag with square brackets <b>[keycaptcha]</b></li>
										<li>Open the page with settings of Contact Form 7</li>
										<li>Paste the copied tag into "Form" section above the line which contains "&lt;p&gt;[submit "Send"]&lt;/p&gt;"</li>
									</ol></p></div>', 'keycaptcha') ?>
						</label>
					</td>
				</tr>
				<tr>
					<th scope="row"><?php _e('KeyCAPTCHA Priview:', 'keycaptcha') ?></th>
					<td>
						<?php
							if (stripos($this->keycaptcha_vars['keycaptcha_code'],'#KC_WSIGN#') != false)
							{
								echo ($this->kc_o->render_js ($this->keycaptcha_vars['keycaptcha_code']));
							}
							else
							{
								echo ('<b style="color:red;">'.__('KeyCAPTCHA code is wrong. To get the correct code please register your site on ', 'keycaptcha').'<a href="https://www.keycaptcha.com" target="_blank">www.keycaptcha.com</a></b>');
							}
						?>
					</td>
				</tr>
			</table>
			<input type="hidden" value="false" id="capcode" name="capcode">
		</fieldset>
		<p class="submit">
			<input type="submit" name="submit" value="<?php _e('Save', 'keycaptcha') ?> &raquo;" />
		</p>
	</form>
</div>
